program O7_Linsengesetzte_Auswertung;
uses crt;

const n1=4; {Anzahl der Messungen mit 200mm Linse}
      n2=4; {Anzahl der Messungen mit 100mm Linse}
      n3=4; {Anzahl der Messungen mit Teleobjektiv Einstellung 1}
      n4=4; {Anzahl der Messungen mit Teleobjektiv Einstellung 2}

      f1=0.003; {Fehler der e Messung 1 bis 4 in Meter}
      f2=0.005;
      f3=0.01;
      f4=0.015;

Type TData1=array[1..n1] of real;
     TData2=array[1..n2] of real;
     TData3=array[1..n3] of real;
     TData4=array[1..n4] of real;

const {Abstnde Dia-Schirm der Messungen 1 bis 4 wie oben beschrieben in Meter}

      a1:TData1=(0.85,0.95,1.05,1.15);
      a2:TData2=(0.75,0.65,0.55,0.45);
      a3:TData3=(1.0,1.1,1.2,1.15);
      a4:TData4=(1.15,1.2,1.1,1.0);

      {Abstnde Linsepos1-Linsepos2 der Messungen 1 bis 4 wie oben beschrieben in Meter}

      e1:TData1=(0.728-0.52,0.862-0.484,0.98-0.468,1.093-0.457);
      e2:TData2=(0.834-0.317,0.728-0.322,0.622-0.328,0.51-0.347);
      e3:TData3=(1.077-0.633,1.176-0.626,1.277-0.623,1.227-0.628);
      e4:TData4=(1.195-0.759,1.245-0.751,1.131-0.762,1.001-0.793);

var aus:text;
    ein:char;

{Statistik Routinen}

var StatN:byte;
    StatV:real;
    StatDV:real;

procedure ClearStat;
begin
  StatN:=0;
  StatV:=0;
  StatDV:=0;
end;

procedure AddValue(v,dv:real);
begin
  inc(Statn);
  StatV:=StatV+v;
  Statdv:=Statdv+dv*dv;
end;

function GetMiddle:real;
begin
  GetMiddle:=StatV/Statn;
end;

function GetError:real;
begin
  GetError:=Sqrt(StatDV)/statn;
end;

{Ende Statistik}

procedure Auswertung;
var n:byte;
    ci,cdi,cf,cdf,mi,mdi:real;

  function f(a,e,i:real):real;
  begin
    f:=(sqr(a-i)-sqr(e))/(4*(a-i));
  end;

  function df(a,e,de,i,di:real):real;
  begin
    df:=sqrt(sqr(2*e/(4*(a-i)))*de*de+di*di/16);
  end;

  function i(a1,e1,a2,e2:real):real;
  var p,q:real;
  begin
    p:=(a2*a2-a1*a1+e1*e1-e2*e2)/(a1-a2);
    q:=(a1*(e2*e2-a2*a2)-a2*(e1*e1-a1*a1))/(a1-a2);
    i:=-p/2-sqrt(p*p/4-q);
  end;

  function di(a1,e1,a2,e2,de:real):real;
  var p,q,h1,h2:real;
  begin
    p:=(a2*a2-a1*a1+e1*e1-e2*e2)/(a1-a2);
    q:=(a1*(e2*e2-a2*a2)-a2*(e1*e1-a1*a1))/(a1-a2);
    h1:=sqrt(p*p/4-q);
    h2:=p/2;
    di:=sqrt(sqr(-e1/(a1-a2)-1/h1*(h2*e1/(a1-a2)+a2*e1/(a1-a2)))*de*de+
             sqr(e2/(a1-a2)-1/h1*(-h2*e2/(a1-a2)-a1*e2/(a1-a2)))*de*de);
  end;

begin
  writeln(aus,'I) Brennweite der beiden Sammellinsen');
  writeln(aus);

  writeln(aus,'Linse 1');
  writeln(aus);
  writeln(aus,' a [m]   e [m]   f [m]');
  ClearStat;
  for n:=1 to n1 do begin
    cf:=f(a1[n],e1[n],0);
    cdf:=df(a1[n],e1[n],f1,0,0);
    AddValue(cf,cdf);
    writeln(aus,a1[n]:7:4,abs(e1[n]):7:4,cf:7:4,'+-',cdf:7:4);
  end;
  writeln(aus);
  writeln(aus,'==> f=',GetMiddle:7:3,'+-',GetError:7:3);
  writeln(aus);

  writeln(aus,'Linse 2');
  writeln(aus);
  writeln(aus,' a [m]   e [m]   f [m]');
  ClearStat;
  for n:=1 to n2 do begin
    cf:=f(a2[n],e2[n],0);
    cdf:=df(a2[n],e2[n],f2,0,0);
    AddValue(cf,cdf);
    writeln(aus,a2[n]:7:4,abs(e2[n]):7:4,cf:7:4,'+-',cdf:7:4);
  end;
  writeln(aus);
  writeln(aus,'==> f=',GetMiddle:7:3,'+-',GetError:7:3);
  writeln(aus);

  writeln(aus,'Teleobjektiv Position 1');
  writeln(aus);
  writeln(aus,' a1 [m]  e1 [m]  a2[m]  e2[m]  i [m]');
  ClearStat;
  for n:=1 to (n3 div 2) do begin
    ci:=i(a3[pred(2*n)],abs(e3[pred(2*n)]),a3[2*n],abs(e3[2*n]));
    cdi:=di(a3[pred(2*n)],abs(e3[pred(2*n)]),a3[2*n],abs(e3[2*n]),f3);
    writeln(aus,a3[pred(2*n)]:7:4,abs(e3[pred(2*n)]):7:4,a3[2*n]:7:4,abs(e3[2*n]):7:4,
                ci:7:4,'+-',cdi:7:4);
    AddValue(ci,cdi);
  end;
  writeln(aus);
  mi:=GetMiddle;
  mdi:=GetError;
  ClearStat;
  writeln(aus,'==> =',mi:7:3,'+-',mdi:7:3);
  writeln(aus);
  writeln(aus,' a1 [m]  e1 [m]  f [m]');
  for n:=1 to n3 do begin
    cf:=f(a3[n],e3[n],mi);
    cdf:=df(a3[n],e3[n],f3,mi,mdi);
    AddValue(cf,cdf);
    writeln(aus,a3[n]:7:4,abs(e3[n]):7:4,cf:7:4,'+-',cdf:7:4);
  end;
  writeln(aus);
  writeln(aus,'==> f=',GetMiddle:7:3,'+-',GetError:7:3);
  writeln(aus);

  writeln(aus,'Teleobjektiv Position 2');
  writeln(aus);
  writeln(aus,' a1 [m]  e1 [m]  a2[m]  e2[m]  i [m]');
  ClearStat;
  for n:=1 to (n4 div 2) do begin
    ci:=i(a4[pred(2*n)],abs(e4[pred(2*n)]),a4[2*n],abs(e4[2*n]));
    cdi:=di(a4[pred(2*n)],abs(e4[pred(2*n)]),a4[2*n],abs(e4[2*n]),f3);
    writeln(aus,a4[pred(2*n)]:7:4,abs(e4[pred(2*n)]):7:4,a4[2*n]:7:4,abs(e4[2*n]):7:4,
                ci:7:4,'+-',cdi:7:4);
    AddValue(ci,cdi);
  end;
  writeln(aus);
  mi:=GetMiddle;
  mdi:=GetError;
  ClearStat;
  writeln(aus,'==> =',mi:7:3,'+-',mdi:7:3);
  writeln(aus);
  writeln(aus,' a1 [m]  e1 [m]  f [m]');
  for n:=1 to n4 do begin
    cf:=f(a4[n],e4[n],mi);
    cdf:=df(a4[n],e4[n],f4,mi,mdi);
    AddValue(cf,cdf);
    writeln(aus,a4[n]:7:4,abs(e4[n]):7:4,cf:7:4,'+-',cdf:7:4);
  end;
  writeln(aus);
  writeln(aus,'==> f=',GetMiddle:7:3,'+-',GetError:7:3);

end;

begin
  writeln('Auswertung zum Versuch O7 Linsengesetze');
  writeln;
  assign(aus,'');
  rewrite(aus);
  auswertung;
  close(aus);
  writeln('Drucken (J/N)?');
  repeat until keypressed;
  while keypressed do ein:=readkey;
  if upcase(ein)='J' then begin
    assign(aus,'PRN');
    rewrite(aus);
    auswertung;
    close(aus);
  end;
end.



  function i(a,e,b,c:real):real;

    function Pow(a:real;b:byte):real;
    var n:byte;
        s:real;
    begin
      s:=1;
      for n:=1 to b do s:=s*a;
      pow:=s;
    end;

  begin
    i:=(-(SQRT(POW(a,4)-4*POW(a,3)*b+2*SQR(a)*(3*SQR(b)-SQR(c)-SQR(e))-4*a*b*(SQR(b)
    -(SQR(c)+SQR(e)))+POW(b,4)-2*SQR(b)*(SQR(c)+SQR(e))+POW(c,4)-2*SQR(c)*SQR(e)+
    POW(e,4))+(SQR(b)+SQR(e)-SQR(c))-SQR(a))/(2*(a-b)));

    i:=(SQRT(POW(a,4)-4*POW(a,3)*b+2*SQR(a)*(3*SQR(b)-SQR(c)-SQR(e))-4*a*b*(SQR(b)-
    (SQR(c)+SQR(e)))+POW(b,4)-2*SQR(b)*(SQR(c)+SQR(e))+POW(c,4)-2*SQR(c)*SQR(e)+
    POW(e,4))+SQR(a)-(SQR(b)+SQR(e)-SQR(c)))/(2*(a-b));
  end;


  {  writeln(aus);
  writeln(aus,'Teleobjektiv Position 2');
  writeln(aus);
  writeln(aus,' a1 [m]  e1 [m]  a2[m]  e2[m]  i [m]          f1 [m]         f2 [m]');
  for n:=1 to (n4 div 2) do begin
    ci:=i(a4[pred(2*n)],abs(e4[pred(2*n)]),a4[2*n],abs(e4[2*n]));
    cdi:=di(a4[pred(2*n)],abs(e4[pred(2*n)]),a4[2*n],abs(e4[2*n]),f4);
    writeln(aus,a4[pred(2*n)]:7:4,abs(e4[pred(2*n)]):7:4,a4[2*n]:7:4,abs(e4[2*n]):7:4,
                ci:7:4,'+-',cdi:7:4,
                f(a4[pred(2*n)],e4[pred(2*n)],ci):7:4,'+-',df(a4[pred(2*n)],e4[pred(2*n)],f3,cdi):7:4,
                f(a4[2*n],e4[2*n],ci):7:4,'+-',df(a4[2*n],e4[2*n],f3,cdi):7:4
                );
  end;}