unit ULaser;
interface
uses UTimer,USBPro,crt;
type TModi=(LPT1_2,LPT,SBPro);
const ausgabemodus:TModi=SBPro;
const maxpunkte=2000;
      maxbild=1023;
      maxpatterns=255;
      maxpattern=1023;

      sfback=1; {zeigt im Statusflag der Patternlist an,
                 dass Pattern rueckwaerts gespielt werden soll}

type PPunkte=^TPunkte;
     TPunkte=array[0..maxpunkte] of record x,y:byte; end;
     PBild=^TBild;
     Tbild=object
       punkte:PPunkte;
       stand,ubergang:byte;
       frequenz,lange:word;
       constructor init(var apunkte:Tpunkte;astand,aubergang:byte;afrequenz,alange:word);
       destructor done;
     end;

     PBilder=^TBilder;
     TBilder=array[0..maxbild] of PBild;

     PPattern=^TPattern;
     TPattern=object
       bild:PBilder;
       aktbild,lange:word;
       constructor init(abild:pbild;alange:word);
       procedure addbild(abild:pbild);
       destructor done;
     end;

     PPatterns=^TPatterns;
     TPatterns=array[0..maxpatterns] of PPattern;
     TPatternlist=array[0..maxpattern] of record
       nr,rep,status:byte;
     end;

     PAnimation=^TAnimation;
     TAnimation=object
       Patterns:PPatterns;
       lange:word;
       Patternlist:TPatternlist;
       langepatternlist,aktpattern:word;
       gesperrt:boolean;
       aktpatternr,aktbild,aktrep:word;
       aktrueck:boolean; {true wenn rueckwaerts}
       constructor init(var apatternlist:TPatternlist;alange:word);
       procedure addbild(abild:PBild);
       procedure addpattern(abild:PBild;alange:word);
       function reset(nr:word):PBild;
       function nextpicture:PBild;
       function maxbildlange:word;
       destructor done;
     end;

procedure newanimation(aanimation:PAnimation);
procedure newbild(abild:Pbild);
procedure playpattern(nr:word);
procedure stop;
procedure continue;

implementation
const data2=888; {LPT2}
      steuer2=890;
      data1=956; {LPT1}
      steuer1=$3be;
      
      aktmax:word=0;
      bild:pbild=nil;
      animation:Panimation=nil;

var aktpos,aktzwischen,aktstand,gesch,stand,geschzwischen,frequenz:word;
    letztbild:boolean;
    nachstanibild,aktanibild:pbild;

  procedure writedata1(value:byte);
  begin
    port[data1]:=value;
    port[steuer1]:=(1+2+8+16) xor 0;
    port[steuer1]:=(1+2+8+16) xor (1+2+4+8);
  end;

  procedure writedata2(value:byte);
  begin
    port[data1]:=value;
    port[steuer1]:=(1+2+8+16) xor 1;
    port[steuer1]:=(1+2+8+16) xor (1+2+4+8);
  end;

procedure bildausgabe;far;
begin
   case ausgabemodus of
    LPT:begin
      writedata1(bild^.punkte^[aktpos].x);
      writedata2(bild^.punkte^[aktpos].y);
    end;
    LPT1_2:begin
      port[data1]:=bild^.punkte^[aktpos].x;
      port[data2]:=bild^.punkte^[aktpos].y;
    end;
  end;
  inc(aktpos);
  if aktpos>aktmax then aktpos:=0;
end;

procedure SBbildaus(pos:pointer;size:word);far;
begin
end;

procedure newbild(abild:PBild);
var aus:proc;
    bildaus:TSBProProc;
    buf:pointer;
begin
  if abild<>nil then begin
    if bild<>nil then dispose(bild,done);
    aus:=bildausgabe;
    aktpos:=0;
    aktmax:=pred(abild^.lange);
    frequenz:=abild^.frequenz;
    bild:=abild;
    letztbild:=true;
    if ausgabemodus=sbpro then begin
      if aktmax<32000 then begin
        buf:=SBProGetBuffer(aktmax*2);
        move(bild^.punkte^,buf^,2*aktmax);
        bildaus:=SBBildAus;
        SBProSetIntProc(BildAus);
        SBProStart(bild^.frequenz);
      end;
    end else begin
      if bild^.frequenz<5000 then settimer(aus,bild^.frequenz)
      else settimer(aus,5000)
    end;
  end else if ausgabemodus=sbpro then sbprostop else endtimer;
end;

procedure animationsausgabeLPT1_2;far;forward;
procedure animationsausgabeLPT;far;forward;

procedure GetAnimationData(var x,y:byte);

  procedure weiter;
  var aus:proc;
      oldfrequenz:word;
  begin
    aktzwischen:=0;
    aktanibild:=nachstanibild;
    nachstanibild:=animation^.nextpicture;
    aktpos:=0;
    aktzwischen:=0;
    aktstand:=0;
    gesch:=aktanibild^.ubergang;
    stand:=aktanibild^.stand;
    oldfrequenz:=frequenz;
    frequenz:=aktanibild^.frequenz;
    if frequenz<>oldfrequenz then begin
      if ausgabemodus=sbpro then SBProFrequenz(frequenz) else begin
        if ausgabemodus=LPT then aus:=animationsausgabeLPT
        else aus:=animationsausgabeLPT1_2;
        if frequenz<5000 then settimer(aus,frequenz)
        else settimer(aus,5000);
      end;
    end;
  end;

begin
  if aktstand<stand then begin
    x:=aktanibild^.punkte^[aktpos].x;
    y:=aktanibild^.punkte^[aktpos].y;
    inc(aktpos);
    if aktpos>aktmax then begin
      aktpos:=0;
      inc(aktstand);
      if (aktstand=stand) and (aktzwischen=gesch) then weiter;
    end;
  end else begin
    if aktzwischen<gesch then begin
      x:=(geschzwischen*aktanibild^.punkte^[aktpos].x+aktzwischen*nachstanibild^.punkte^[aktpos].x) div gesch;
      y:=(geschzwischen*aktanibild^.punkte^[aktpos].y+aktzwischen*nachstanibild^.punkte^[aktpos].y) div gesch;
      inc(aktpos);
      if aktpos>aktmax then begin
        aktpos:=0;
        inc(aktzwischen);
        if aktzwischen=gesch then weiter;
      end;
      geschzwischen:=gesch-aktzwischen;
    end;
  end;
end;

procedure animationsausgabeLPT1_2;{far;}
var x,y:byte;
begin
  GetAnimationData(x,y);
  writedata1(x);
  writedata2(y);
end;

procedure animationsausgabeLPT;{far;}
var x,y:byte;
begin
  GetAnimationData(x,y);
  port[data1]:=x;
  port[data2]:=y;
end;

procedure SBAniAus(pos:pointer;size:word);far;
type TByte=array[0..32000,0..1] of byte;
var n:word;
begin
  if size=2048 then sound(100);
  for n:=0 to size div 2 do GetAnimationData(TByte(pos^)[n,0],TByte(pos^)[n,1]);
  nosound;
end;

procedure newanimation(aanimation:panimation);
var aus:proc;
    aniaus:TSBProProc;
begin
  if (aanimation<>nil) then begin
    if animation<>nil then dispose(animation,done);
    animation:=aanimation;
    if ausgabemodus=LPT then aus:=animationsausgabeLPT
    else aus:=animationsausgabeLPT1_2;
    aktmax:=pred(animation^.maxbildlange);
    aktanibild:=animation^.reset(0);
    nachstanibild:=animation^.nextpicture;
    aktpos:=0;
    aktzwischen:=0;
    aktstand:=0;
    gesch:=aktanibild^.ubergang;
    stand:=aktanibild^.stand;
    letztbild:=false;
    frequenz:=aktanibild^.frequenz;
    if ausgabemodus=SBPro then begin
      SBAniAus(SBProGetBuffer(4096),4096);
      AniAus:=SBAniAus;
      SBProSetIntProc(AniAus);
      SBProStart(frequenz);
    end else begin
      if frequenz<5000 then settimer(aus,frequenz)
      else settimer(aus,5000);
    end;
  end else if ausgabemodus=sbpro then SBProStop else endtimer;
end;

procedure stop;
begin
  if ausgabemodus=SBPro then begin
    SBProPause;
  end else begin
    endtimer;
    case ausgabemodus of
      LPT:begin
        writedata1(0);
        writedata2(0);
      end;
      LPT1_2:begin
        port[data1]:=0;
        port[data2]:=0;
      end;
    end;
  end;
end;

procedure continue;
var aus:proc;
begin
  if letztbild and (bild<>nil) then begin
    if ausgabemodus=SBPro then SBPRoContinue else begin
      aus:=BildAusgabe;
      aktpos:=0;
      aktmax:=pred(bild^.lange);
      frequenz:=bild^.frequenz;
      letztbild:=true;
      if bild^.frequenz<5000 then settimer(aus,bild^.frequenz)
      else settimer(aus,5000);
    end;
  end else if animation<>nil then begin
    if ausgabemodus=SBPro then SBProContinue else begin
      if ausgabemodus=LPT then aus:=animationsausgabeLPT
      else aus:=animationsausgabeLPT1_2;
      aktmax:=pred(animation^.maxbildlange);
      aktanibild:=animation^.reset(0);
      nachstanibild:=animation^.nextpicture;
      aktpos:=0;
      aktzwischen:=0;
      aktstand:=0;
      gesch:=aktanibild^.ubergang;
      stand:=aktanibild^.stand;
      letztbild:=false;
      frequenz:=aktanibild^.frequenz;
      if frequenz<5000 then settimer(aus,frequenz)
      else settimer(aus,5000)
    end;
  end;
end;

procedure playpattern(nr:word);
var aus:proc;
    aniaus:TSbProProc;
begin
  if not letztbild and (animation<>nil) and
    (animation^.patternlist[nr].nr<animation^.lange) then begin
    if ausgabemodus=LPT then aus:=animationsausgabeLPT
    else aus:=animationsausgabeLPT1_2;
    aktmax:=pred(animation^.maxbildlange);
    aktanibild:=animation^.reset(nr);
    nachstanibild:=animation^.nextpicture;
    aktpos:=0;
    aktzwischen:=0;
    aktstand:=0;
    gesch:=aktanibild^.ubergang;
    stand:=aktanibild^.stand;
    letztbild:=false;
    frequenz:=aktanibild^.frequenz;
    if ausgabemodus=SBPro then begin
      SBAniAus(SBProGetBuffer(4096),4096);
      AniAus:=SBAniAus;
      SBProSetIntProc(AniAus);
      SBProStart(frequenz);
    end else begin
      if frequenz<5000 then settimer(aus,frequenz)
      else settimer(aus,5000)
    end;
  end;
end;

constructor tbild.init(var apunkte:Tpunkte;astand,aubergang:byte;afrequenz,alange:word);
begin
  getmem(punkte,alange*2*sizeof(byte));
  move(apunkte,punkte^,alange*2*sizeof(byte));
  stand:=astand;
  ubergang:=aubergang;
  frequenz:=afrequenz;
  lange:=alange;
end;

destructor Tbild.done;
begin
  freemem(punkte,lange*2*sizeof(byte));
end;

constructor tPattern.init(abild:pbild;alange:word);
var n:byte;
begin
  getmem(bild,alange*sizeof(pointer));
  fillchar(bild^,alange*sizeof(pointer),#0);
  aktbild:=0;
  lange:=alange;
  addbild(abild);
end;

procedure TPattern.addbild(abild:pbild);
begin
  if aktbild<lange then begin
    bild^[aktbild]:=abild;
    inc(aktbild);
  end;
end;

destructor TPattern.done;
var n:byte;
begin
  n:=0;
  while (bild^[n]<>nil) and (n<lange) do begin
    dispose(bild^[n],done);
    inc(n);
  end;
  freemem(bild,lange*sizeof(pointer));
end;

constructor TAnimation.init(var apatternlist:TPatternlist;alange:word);
{lange enthlt anzahl von patterns}
begin
  lange:=alange;
  patternlist:=apatternlist;
  langepatternlist:=0;
  while (patternlist[langepatternlist].nr<>$ff) and
        (langepatternlist<maxpattern) do inc(langepatternlist);
  getmem(patterns,alange*sizeof(pointer));
  fillchar(patterns^,alange*sizeof(pointer),#0);
  aktpatternr:=0;
  gesperrt:=false;
end;

procedure TAnimation.addbild(abild:PBild);
begin
  if not gesperrt then patterns^[pred(aktpatternr)]^.addbild(abild);
end;

procedure TAnimation.addpattern(abild:PBild;alange:word);
begin
  if aktpatternr<lange then begin
    new(patterns^[aktpatternr],init(abild,alange));
    inc(aktpatternr);
  end else begin
    dispose(abild,done);
    gesperrt:=true;
  end;
end;

function TAnimation.reset(nr:word):PBild;
begin
  if patternlist[aktpatternr].nr>pred(lange) then nr:=0;
  aktpatternr:=nr;
  aktrep:=0;
  aktrueck:=(patternlist[aktpattern].status and sfback)>0;
  if aktrueck then aktbild:=pred(patterns^[patternlist[aktpatternr].nr]^.lange)
  else aktbild:=0;
  reset:=patterns^[patternlist[aktpatternr].nr]^.bild^[aktbild];
end;

function TAnimation.nextpicture:PBild;

  procedure nextpattern;
  begin
    inc(aktpatternr);
    if aktpatternr>=langepatternlist then aktpatternr:=0;
    aktrueck:=(patternlist[aktpatternr].status and sfback)>0;
    aktrep:=0;
    if aktrueck then aktbild:=pred(patterns^[patternlist[aktpatternr].nr]^.lange)
    else aktbild:=0;
  end;

  procedure thisagain;
  begin
    if aktrueck then aktbild:=pred(patterns^[patternlist[aktpatternr].nr]^.lange)
    else aktbild:=0;
  end;

begin
  if aktrueck then begin
    if aktbild>0 then dec(aktbild)
    else begin
      inc(aktrep);
      if aktrep>patternlist[aktpatternr].rep then nextpattern
      else thisagain;
    end;
  end else begin
    inc(aktbild);
    if patterns^[patternlist[aktpatternr].nr]^.lange<=aktbild then begin
      inc(aktrep);
      if aktrep>patternlist[aktpatternr].rep then nextpattern
      else thisagain;
    end;
  end;
  nextpicture:=patterns^[patternlist[aktpatternr].nr]^.bild^[aktbild]
end;

function TAnimation.maxbildlange:word;
begin
  maxbildlange:=patterns^[0]^.bild^[0]^.lange;
end;

destructor TAnimation.done;
var n:word;
begin
  for n:=0 to pred(lange) do if patterns^[n]<>nil then patterns^[n]^.done;
  freemem(patterns,lange*sizeof(pointer));
end;

begin
  case ausgabemodus of
    LPT:begin
      writedata1(0);
      writedata2(0);
    end;
    LPT1_2:begin
      port[data1]:=0;
      port[data2]:=0;
    end;
  end;
end.