unit USBPro;
interface
Type TSBProProc=procedure(pos:pointer;size:word);

function SBProGetBuffer(size:word):pointer; {Size muss durch 4 teilbar sein!}
procedure SBProFreeBuffer;
procedure SBProSetIntProc(proc:TSBProProc);
procedure SBProStart(frequenz:word);
procedure SBProStop;
procedure SBProPause;
procedure SBProContinue;
procedure SBProSetIntDMAPort(int,dma:byte;port:word);
procedure SBProFrequenz(frequenz:word);
procedure SBProSetVolume(l,r:byte);

implementation
uses crt,dos;

const an:boolean=false;
      IntProcDa:boolean=false;
      InIntProc:boolean=false;
      buf:pointer=nil;
      bufh:pointer=nil;
      bufanfang:boolean=true;
      skip:pointer=nil;
      SBProInt:byte=5;
      SBProDMA:byte=1;
      SBProPort:word=$220;
      intverbogen:boolean=false;
      altgesperrt:boolean=true;
      pausiert:boolean=false;
var oldex:pointer;
    hsize,bufsize:word;
    skipsize:word;
    OldInt:pointer;
    intmask:byte;
    IntProc:TSBProProc;

function lies_dsp : Byte;
var
   counter : Integer;
   ende    : Boolean;

begin
   ende := false;
   counter := 0;
   while(not(ende)) do
   begin
      inc(counter);
      ende := (Port[SBProPort + $0E] and $080) = $080;
      if counter = 100 then begin
	 writeln('DSP kann nicht gelesen werden');
         halt;
       end;
   end;
   lies_dsp := Port[SBProPort + $0A];
end;

procedure init_dsp;
var
   counter : Integer;
   ende    : Boolean;

begin
   ende := false;
   counter := 0;
   Port[SBProPort + $06] := $01;
   delay(1);
   Port[SBProPort + $06] := $00;
   while(not(ende)) do
   begin
      inc(counter);
      ende := (lies_dsp = $0AA);
      if (counter = 100) then begin
	 writeln('Falsche Basisadresse oder Reset-Error');
         halt;
       end;
   end;
end;

procedure schreib_dsp(wert : Byte);
var
   counter : word;
   ende    : Boolean;

begin
   ende := false;
   counter := 0;   while(not(ende)) do
   begin
      inc(counter);
      ende := (Port[SBProPort + $0C] and $080) = $00;
      if counter = 60000 then begin
	 writeln('DSP kann nicht beschrieben werden');
         halt;
      end;
   end;
   Port[SBProPort + $0C] := wert;
end;

procedure nextpage(max:word);
var adresse,grenze:longint;
begin
  adresse:=seg(heapPtr^)*16+ofs(heapPtr^);
  grenze:=$10000+(adresse shr 16) shl 16;
  if memavail < grenze-adresse + max then
    begin
    write('fehler kein speicher');
    halt;
  end;
  skipsize:=word(grenze-adresse);
  getmem(skip,skipsize);
end;

function SBProGetBuffer(size:word):pointer;
Type TByteArray=array[0..65534] of byte;
begin
  SBProFreeBuffer;
  bufsize:=size;
  hsize:=bufsize div 2;
  nextpage(size);      {Puffer muss an physikalischer Seitengrenze beginnen}
  getmem(buf,size);
  bufh:=@TByteArray(buf^)[size div 2];
  SBProGetBuffer:=buf;
end;

procedure SBProFreeBuffer;
begin
  if skip<>nil then freemem(skip,skipsize);
  if buf<>nil then freemem(buf,bufsize);
end;

procedure SBProSetIntProc(proc:TSBProProc);
begin
  IntProc:=proc;
  IntProcDa:=true;
end;

procedure SBProSetIntDMAPort(int,dma:byte;port:word);
begin
  SBProInt:=int;
  SBProDMA:=DMA;
  SBProPort:=port;
end;

procedure SBProInterrupt;interrupt;
var ein:byte;
begin
  if IntProcDa and (not InIntProc) then begin
    InIntProc:=true;
    if bufanfang then IntProc(buf,hsize) else IntProc(bufh,hsize);
    bufanfang:=not bufanfang;
    InIntProc:=false;
  end;
  ein:=port[$22e]; {Interrupt bestaetigen}
  port[$20]:=$20;
end;

procedure SBProStart(frequenz:word);
var ints,tc:byte;
    seite,adr,len:word;
begin
  an:=true;
  intmask:=1 shl SBProInt;
  init_dsp;
  schreib_dsp($d1); {Lautsprecher an}
  getintvec(SBProInt+8,oldint);  {Interrupt umbiegen}
  asm cli end;
    ints:=port[$21];
    altgesperrt:=(ints and intmask)=IntMask;
    port[$21]:=ints or IntMask;
    setintvec(SBProInt+8,@SBProInterrupt);
    intverbogen:=true;
    port[$21]:=ints and (not IntMask);   {Interrupt freigeben}
  asm sti end;

  seite:=seg(buf^) shr 12;
  adr:=ofs(buf^) + ((seg(buf^) and ($0fff) shl 4));
  if adr<ofs(buf^) then inc(seite);

  port[$a]:=$4 or SBProDMA;     {DMA: Sounddaten ausgeben}
  port[$c]:=$0;           {clear FlipFlop}
  port[$2]:=lo(adr);
  port[$2]:=hi(adr);
  port[$83]:=seite;
  len:=pred(bufsize);
  port[$3]:=lo(len);
  port[$3]:=hi(len);
  port[$b]:=$59;          {AutoInit Ausgabe}
  port[$a]:=SBProDMA;

  schreib_dsp($40);       {Samplefrequenz}
  tc:=256-round(1000000/(frequenz*2));
  schreib_dsp(tc);

  port[$224]:=$0e;  {Mixer auf Stereo}
  port[$225]:=$13;


  schreib_dsp($48);       {Blocklnge an DSP}
  schreib_dsp(lo(hsize)); {Nach halbem Puffer Interrupt}
  schreib_dsp(hi(hsize));

  schreib_dsp($1c);        {unbeschleunigter Auto-Init: Start!}
end;

procedure SBProStop;
var ints:byte;
begin
  if an then begin
    schreib_dsp($da);        {Uebertragung beenden}
    schreib_dsp($d3);        {lautsprecher aus}
  end;
  if intverbogen then begin
    asm cli end;             {interrupt rueckbiegen}
      ints:=port[$21];
      port[$21]:=ints or IntMask;
      setintvec(SBProInt+8,oldint);
      intverbogen:=false;
      if not altgesperrt then port[$21]:=ints and (not IntMask);
    asm sti end;
  end;
end;

procedure SBProPause;
begin
  if an then begin
    pausiert:=true;
    schreib_dsp($d0);
  end;
end;

procedure SBProContinue;
begin
  if pausiert and an then begin
    pausiert:=false;
    schreib_dsp($d4);
  end;
end;

procedure SBProFrequenz(frequenz:word);
var tc:byte;
begin
  tc:=256-round(1000000/(frequenz*2));
  schreib_dsp($40);       {Samplefrequenz}
  schreib_dsp(tc);
end;

procedure MixerOut(a,b:byte);
begin
  port[SBProPort+$4]:=a;
  port[SBProPort+$5]:=b;
end;

procedure SBProSetVolume(l,r:byte);
begin
  mixerout(0,0);
  mixerout(4,l shl 4+(r and $f));   {Voice}
  mixerout($22,$FF);                {Master}
end;


procedure myexit;far;
begin
  if an or intverbogen then SBProstop;
  exitproc:=oldex;
end;

begin
  oldex:=exitproc;
  exitproc:=@myexit;
  SBProSetVolume($7,$7);
end.